/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.books.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for BooksLayerGeoData.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BooksLayerGeoData extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Common common;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Geo geo;

  /**

   * The value returned may be {@code null}.
   */
  public Common getCommon() {
    return common;
  }

  /**

   * The value set may be {@code null}.
   */
  public BooksLayerGeoData setCommon(Common common) {
    this.common = common;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Geo getGeo() {
    return geo;
  }

  /**

   * The value set may be {@code null}.
   */
  public BooksLayerGeoData setGeo(Geo geo) {
    this.geo = geo;
    return this;
  }

  /**
   * Model definition for BooksLayerGeoDataCommon.
   */
  public static final class Common extends GenericJson {

    /**
     * The language of the information url and description.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String lang;

    /**
     * The URL for the preview image information.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String previewImageUrl;

    /**
     * The description for this location.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String snippet;

    /**
     * The URL for information for this location. Ex: wikipedia link.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String snippetUrl;

    /**
     * The display title and localized canonical name to use when searching for this entity on Google
     * search.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String title;

    /**
     * The language of the information url and description.
     * The value returned may be {@code null}.
     */
    public String getLang() {
      return lang;
    }

    /**
     * The language of the information url and description.
     * The value set may be {@code null}.
     */
    public Common setLang(String lang) {
      this.lang = lang;
      return this;
    }

    /**
     * The URL for the preview image information.
     * The value returned may be {@code null}.
     */
    public String getPreviewImageUrl() {
      return previewImageUrl;
    }

    /**
     * The URL for the preview image information.
     * The value set may be {@code null}.
     */
    public Common setPreviewImageUrl(String previewImageUrl) {
      this.previewImageUrl = previewImageUrl;
      return this;
    }

    /**
     * The description for this location.
     * The value returned may be {@code null}.
     */
    public String getSnippet() {
      return snippet;
    }

    /**
     * The description for this location.
     * The value set may be {@code null}.
     */
    public Common setSnippet(String snippet) {
      this.snippet = snippet;
      return this;
    }

    /**
     * The URL for information for this location. Ex: wikipedia link.
     * The value returned may be {@code null}.
     */
    public String getSnippetUrl() {
      return snippetUrl;
    }

    /**
     * The URL for information for this location. Ex: wikipedia link.
     * The value set may be {@code null}.
     */
    public Common setSnippetUrl(String snippetUrl) {
      this.snippetUrl = snippetUrl;
      return this;
    }

    /**
     * The display title and localized canonical name to use when searching for this entity on Google
     * search.
     * The value returned may be {@code null}.
     */
    public String getTitle() {
      return title;
    }

    /**
     * The display title and localized canonical name to use when searching for this entity on Google
     * search.
     * The value set may be {@code null}.
     */
    public Common setTitle(String title) {
      this.title = title;
      return this;
    }

  }

  /**
   * Model definition for BooksLayerGeoDataGeo.
   */
  public static final class Geo extends GenericJson {

    /**
     * The boundary of the location as a set of loops containing pairs of latitude, longitude
     * coordinates.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<java.util.List<Boundary>> boundary;

    /**
     * The cache policy active for this data. EX: UNRESTRICTED, RESTRICTED, NEVER
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String cachePolicy;

    /**
     * The country code of the location.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String countryCode;

    /**
     * The latitude of the location.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Double latitude;

    /**
     * The longitude of the location.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Double longitude;

    /**
     * The type of map that should be used for this location. EX: HYBRID, ROADMAP, SATELLITE, TERRAIN
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String mapType;

    /**
     * The viewport for showing this location. This is a latitude, longitude rectangle.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Viewport viewport;

    /**
     * The Zoom level to use for the map. Zoom levels between 0 (the lowest zoom level, in which the
     * entire world can be seen on one map) to 21+ (down to individual buildings). See:
     * https://developers.google.com/maps/documentation/staticmaps/#Zoomlevels
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer zoom;

    /**
     * The boundary of the location as a set of loops containing pairs of latitude, longitude
     * coordinates.
     * The value returned may be {@code null}.
     */
    public java.util.List<java.util.List<Boundary>> getBoundary() {
      return boundary;
    }

    /**
     * The boundary of the location as a set of loops containing pairs of latitude, longitude
     * coordinates.
     * The value set may be {@code null}.
     */
    public Geo setBoundary(java.util.List<java.util.List<Boundary>> boundary) {
      this.boundary = boundary;
      return this;
    }

    /**
     * The cache policy active for this data. EX: UNRESTRICTED, RESTRICTED, NEVER
     * The value returned may be {@code null}.
     */
    public String getCachePolicy() {
      return cachePolicy;
    }

    /**
     * The cache policy active for this data. EX: UNRESTRICTED, RESTRICTED, NEVER
     * The value set may be {@code null}.
     */
    public Geo setCachePolicy(String cachePolicy) {
      this.cachePolicy = cachePolicy;
      return this;
    }

    /**
     * The country code of the location.
     * The value returned may be {@code null}.
     */
    public String getCountryCode() {
      return countryCode;
    }

    /**
     * The country code of the location.
     * The value set may be {@code null}.
     */
    public Geo setCountryCode(String countryCode) {
      this.countryCode = countryCode;
      return this;
    }

    /**
     * The latitude of the location.
     * The value returned may be {@code null}.
     */
    public Double getLatitude() {
      return latitude;
    }

    /**
     * The latitude of the location.
     * The value set may be {@code null}.
     */
    public Geo setLatitude(Double latitude) {
      this.latitude = latitude;
      return this;
    }

    /**
     * The longitude of the location.
     * The value returned may be {@code null}.
     */
    public Double getLongitude() {
      return longitude;
    }

    /**
     * The longitude of the location.
     * The value set may be {@code null}.
     */
    public Geo setLongitude(Double longitude) {
      this.longitude = longitude;
      return this;
    }

    /**
     * The type of map that should be used for this location. EX: HYBRID, ROADMAP, SATELLITE, TERRAIN
     * The value returned may be {@code null}.
     */
    public String getMapType() {
      return mapType;
    }

    /**
     * The type of map that should be used for this location. EX: HYBRID, ROADMAP, SATELLITE, TERRAIN
     * The value set may be {@code null}.
     */
    public Geo setMapType(String mapType) {
      this.mapType = mapType;
      return this;
    }

    /**
     * The viewport for showing this location. This is a latitude, longitude rectangle.
     * The value returned may be {@code null}.
     */
    public Viewport getViewport() {
      return viewport;
    }

    /**
     * The viewport for showing this location. This is a latitude, longitude rectangle.
     * The value set may be {@code null}.
     */
    public Geo setViewport(Viewport viewport) {
      this.viewport = viewport;
      return this;
    }

    /**
     * The Zoom level to use for the map. Zoom levels between 0 (the lowest zoom level, in which the
     * entire world can be seen on one map) to 21+ (down to individual buildings). See:
     * https://developers.google.com/maps/documentation/staticmaps/#Zoomlevels
     * The value returned may be {@code null}.
     */
    public Integer getZoom() {
      return zoom;
    }

    /**
     * The Zoom level to use for the map. Zoom levels between 0 (the lowest zoom level, in which the
     * entire world can be seen on one map) to 21+ (down to individual buildings). See:
     * https://developers.google.com/maps/documentation/staticmaps/#Zoomlevels
     * The value set may be {@code null}.
     */
    public Geo setZoom(Integer zoom) {
      this.zoom = zoom;
      return this;
    }

    /**
     * Model definition for BooksLayerGeoDataGeoBoundary.
     */
    public static final class Boundary extends GenericJson {

      /**
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private Long latitude;

      /**
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private Long longitude;

      /**

       * The value returned may be {@code null}.
       */
      public Long getLatitude() {
        return latitude;
      }

      /**

       * The value set may be {@code null}.
       */
      public Boundary setLatitude(Long latitude) {
        this.latitude = latitude;
        return this;
      }

      /**

       * The value returned may be {@code null}.
       */
      public Long getLongitude() {
        return longitude;
      }

      /**

       * The value set may be {@code null}.
       */
      public Boundary setLongitude(Long longitude) {
        this.longitude = longitude;
        return this;
      }

    }
    /**
     * The viewport for showing this location. This is a latitude, longitude rectangle.
     */
    public static final class Viewport extends GenericJson {

      /**
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private Hi hi;

      /**
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private Lo lo;

      /**

       * The value returned may be {@code null}.
       */
      public Hi getHi() {
        return hi;
      }

      /**

       * The value set may be {@code null}.
       */
      public Viewport setHi(Hi hi) {
        this.hi = hi;
        return this;
      }

      /**

       * The value returned may be {@code null}.
       */
      public Lo getLo() {
        return lo;
      }

      /**

       * The value set may be {@code null}.
       */
      public Viewport setLo(Lo lo) {
        this.lo = lo;
        return this;
      }

      /**
       * Model definition for BooksLayerGeoDataGeoViewportHi.
       */
      public static final class Hi extends GenericJson {

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private Double latitude;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private Double longitude;

        /**

         * The value returned may be {@code null}.
         */
        public Double getLatitude() {
          return latitude;
        }

        /**

         * The value set may be {@code null}.
         */
        public Hi setLatitude(Double latitude) {
          this.latitude = latitude;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public Double getLongitude() {
          return longitude;
        }

        /**

         * The value set may be {@code null}.
         */
        public Hi setLongitude(Double longitude) {
          this.longitude = longitude;
          return this;
        }

      }
      /**
       * Model definition for BooksLayerGeoDataGeoViewportLo.
       */
      public static final class Lo extends GenericJson {

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private Double latitude;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private Double longitude;

        /**

         * The value returned may be {@code null}.
         */
        public Double getLatitude() {
          return latitude;
        }

        /**

         * The value set may be {@code null}.
         */
        public Lo setLatitude(Double latitude) {
          this.latitude = latitude;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public Double getLongitude() {
          return longitude;
        }

        /**

         * The value set may be {@code null}.
         */
        public Lo setLongitude(Double longitude) {
          this.longitude = longitude;
          return this;
        }

      }
    }
  }
}
